var React = require('react');
var Router = require('react-router');
var { DefaultRoute, Route, RouteHandler, Link } = Router;
var TransitionGroup = require('react/lib/ReactCSSTransitionGroup');
var assign = require('react/lib/Object.assign');

var NavBar = React.createClass({
  style: {
    display: 'flex',
    width: '100%',
    position: 'fixed',
    bottom: 0,
    left: 0,
    background: '#444',
  },

  linkStyle: {
    flex: '1',
    color: '#fff',
    textAlign: 'center',
    textDecoration: 'none',
    borderRight: '1px solid #666',
    padding: '20px',
  },

  render () {
    return (
      <div style={this.style}>
        <Link style={this.linkStyle} to="feed">Feed</Link>
        <Link style={this.linkStyle} to="settings">Settings</Link>
      </div>
    );
  }
});

var App = React.createClass({
  mixins: [ Router.State ],

  style: {
    display: 'flex',
    height: '100%',
    background: '#eee',
  },

  containerStyle: {
    display: 'flex',
    flex: '1',
    height: '100%'
  },

  render () {
    var routeKey = this.getRoutes()[1].name;
    return (
      <div style={this.style}>
        <TransitionGroup component="div" transitionName="example" style={this.containerStyle}>
          <RouteHandler key={routeKey}/>
        </TransitionGroup>
        <NavBar/>
      </div>
    );
  }
});

var range = (start, end) => {
  var arr = [];
  for (var i = 0, l = end; i < l; i ++)
    arr.push(null)
  return arr;
};

var rootViewStyle = {
    flex: '1',
    padding: 10
};

var Feed = React.createClass({
  style: assign({}, rootViewStyle, {
    background: 'hsl(100, 50%, 50%)',
  }),
  render () {
    var items = range(1, 100).map((n) => {
      return (
        <div style={{borderBottom: '1px solid #ccc'}}>
          <h2>Blah {n}</h2>
          <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
        </div>
      );
    });
    return <div style={this.style}>{items}</div>;
  }
});

var FeedItem = React.createClass({
  render () {
    return (
      <div>
        FeedItem
      </div>
    );
  }
});

var Settings = React.createClass({
  style: assign({}, rootViewStyle, {
    background: 'hsl(200, 50%, 50%)',
  }),

  render () {
    return (
      <div style={this.style}>
        Settings
      </div>
    );
  }
});

var Profile = React.createClass({
  render () {
    return (
      <div>
        Profile
      </div>
    );
  }
});

var Privacy = React.createClass({
  render () {
    return (
      <div>
        Privacy
      </div>
    );
  }
});

var routes = (
  <Route handler={App} ignoreScrollBehavior={true}>
    <DefaultRoute name="feed" handler={Feed}>
      <Route name="feed-item" path=":id" handler={FeedItem}/>
    </DefaultRoute>
    <Route name="settings" handler={Settings}>
      <Route name="profile" handler={Profile}/>
      <Route name="privacy" handler={Privacy}/>
    </Route>
  </Route>
);

Router.run(routes, function (Handler) {
  React.render(<Handler/>, document.body);
});
