'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; desc = parent = getter = undefined; _again = false; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _URLUtils = require('./URLUtils');

var _ChangeEmitter2 = require('./ChangeEmitter');

var _ChangeEmitter3 = _interopRequireDefault(_ChangeEmitter2);

var _Location = require('./Location');

var _Location2 = _interopRequireDefault(_Location);

var RequiredSubclassMethods = ['pushState', 'replaceState', 'go'];

function createRandomKey() {
  return Math.random().toString(36).substr(2);
}

/**
 * A history interface that normalizes the differences across
 * various environments and implementations. Requires concrete
 * subclasses to implement the following methods:
 *
 * - pushState(state, path)
 * - replaceState(state, path)
 * - go(n)
 */

var History = (function (_ChangeEmitter) {
  function History() {
    var options = arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, History);

    _get(Object.getPrototypeOf(History.prototype), 'constructor', this).call(this);

    this.parseQueryString = options.parseQueryString || _URLUtils.parseQueryString;
    this.stringifyQuery = options.stringifyQuery || _URLUtils.stringifyQuery;
    this.location = null;

    RequiredSubclassMethods.forEach(function (method) {
      (0, _invariant2['default'])(typeof this[method] === 'function', '%s needs a "%s" method', this.constructor.name, method);
    }, this);
  }

  _inherits(History, _ChangeEmitter);

  _createClass(History, [{
    key: 'back',
    value: function back() {
      this.go(-1);
    }
  }, {
    key: 'forward',
    value: function forward() {
      this.go(1);
    }
  }, {
    key: '_createState',
    value: function _createState(state) {
      state = state || {};

      if (!state.key) state.key = createRandomKey();

      return state;
    }
  }, {
    key: '_createLocation',
    value: function _createLocation(path, state, navigationType) {
      var pathname = (0, _URLUtils.getPathname)(path);
      var queryString = (0, _URLUtils.getQueryString)(path);
      var query = queryString ? this.parseQueryString(queryString) : null;
      return new _Location2['default'](pathname, query, state, navigationType);
    }
  }, {
    key: 'makePath',

    /**
     * Returns a full URL path from the given pathname and query.
     */
    value: function makePath(pathname, query) {
      if (query) {
        if (typeof query !== 'string') query = this.stringifyQuery(query);

        if (query !== '') return pathname + '?' + query;
      }

      return pathname;
    }
  }, {
    key: 'makeHref',

    /**
     * Returns a string that may safely be used to link to the given
     * pathname and query.
     */
    value: function makeHref(pathname, query) {
      return this.makePath(pathname, query);
    }
  }]);

  return History;
})(_ChangeEmitter3['default']);

exports['default'] = History;
module.exports = exports['default'];